/*===================================
		Copyright Yakibomb
*///=================================

function VSCONDS_CLEANUP()
{
	if ( !VSConds_FirstBootComplete ) return;
	local attachment_list = {};
	
	foreach ( key, value in ROOT )
	{
		if ( typeof(value) == "array" && startswith(key, "VSCOND_ATTACH") ) {
			attachment_list[key] <- value;
		}
		else if ( typeof(value) == "table" && startswith(key, "VSCOND_TABLE_") ) {
			attachment_list[key] <- value;
		}
	}
	foreach ( key, value in attachment_list )
	{
		if ( startswith(key, "VSCOND_ATTACH_CHILD_") ) {
			local child_array_from_ROOT = ROOT[key]
			foreach ( index, attachment in child_array_from_ROOT ) {
				if ( attachment && attachment.IsValid() ) attachment.Kill();
			}
		}
		else if ( startswith(key, "VSCOND_TABLE_") ) {
			local ent_index = split(key,"_");
			ent_index = ent_index[2].tointeger();
			VSCONDS_RemoveThinkToCond_ALL(ent_index);
			
			local ent_data = ROOT[key];
			local ent = ent_data[VSCond_MAX_Conditions];
			local ent_validate = ent_data[VSCond_MAX_Conditions + 1];
			
			if ( ent == ent_validate 
			  && ent.IsValid() )
			{
				foreach (condition,duration in ent_data ) {
					if ( condition >= VSCond_MAX_Conditions ) continue
					ent.RemoveVSCond(condition);
					//VSCOND_ENTS_UNDER_CONDS.remove(VSCOND_ENTS_UNDER_CONDS.find(ent_data));
				}
			}
		}
	//else if ( startswith(key, "VSCOND_ATTACHED_ENT") ) {
		delete ROOT[key];
	}
	foreach ( key, wearable in VSCOND_HIDDEN_WEARABLES ) {
		if ( wearable && wearable.IsValid() ) wearable.Kill();
	}
}