//===================================
// Copyright Yakibomb
//===================================

function VSCONDS_ADD_CONDITION(CONDITION_NAME) {
// Some checks
// First if it's a string, else ERROR
	local VS_CONDITION_FUNC_NAME;
	local VS_CONDITION_FUNC;

	if ( type(CONDITION_NAME) == "string" ) { 
		VS_CONDITION_FUNC_NAME = "VSCONDFUNC_" + CONDITION_NAME;
		VS_CONDITION_FUNC = ROOT[CONDITION_NAME];
	}
	else throw "ERROR in VSCONDS : Please I need class func in quotes so I can get it from ROOT!";
	
// Last if function already exists under getroottable()
	if ( VSCOND_COND_NAMES.find(CONDITION_NAME) ) return printl("ERROR in VSCONDS : " + CONDITION_NAME.tostring() + " could not process because function already exists!!");
	
// Copies over function before converting to constant

	ROOT[VS_CONDITION_FUNC_NAME] <- VS_CONDITION_FUNC;
	VSCOND_COND_FUNC.append(VS_CONDITION_FUNC);
	
// Deletes original class, then converts name to constant
	delete ROOT[CONDITION_NAME];
	VSCOND_COND_NAMES.append(CONDITION_NAME);
	
	local COND_ID = VSCOND_COND_NAMES.len() - 1;

	ROOT[CONDITION_NAME] <- COND_ID;
	
// Begins to implement info to copied function name
	ROOT[VS_CONDITION_FUNC_NAME]["condition"] <- COND_ID ;
	ROOT[VS_CONDITION_FUNC_NAME]["condition_name"] <- CONDITION_NAME ;
	
	local base_function_think = VSConds_Base["Think"];
	local condition_func = ROOT[VS_CONDITION_FUNC_NAME];
	foreach ( key, kv in condition_func )
	{
		if ( key == "condition" ) continue
		
		if ( key == "Think" ) {
			if ( kv != base_function_think ) {
				ROOT[VS_CONDITION_FUNC_NAME]["use_think_script"] <- true;
			}
			else 
				ROOT[VS_CONDITION_FUNC_NAME]["use_think_script"] <- false;
		}
		
		ROOT[VS_CONDITION_FUNC_NAME][key] <- kv;
	}
//Sets up condition states
//states are in vsconds_constants.nut
	local bits = 0;
	foreach ( key, kv in condition_func )
	{
		if ( key == "removedByDeath"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_DEATH;
		else if ( key == "removedByResupply"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_RESUPPLY;
		else if ( key == "removedByTeamChange"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_TEAMCHANGE;
		else if ( key == "removedByClassChange"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_CLASSCHANGE;
		else if ( key == "removedByCommand"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_COMMAND;
	}
	ROOT[VS_CONDITION_FUNC_NAME]["settingsBits"] <- bits;
// end condition states setup

	printl(CONDITION_NAME + " | Success!");
}

function VSCONDS_COMPILE_CONDITIONS() {
	foreach ( cond, value in ROOT )
	{
		if (typeof(value) != "class" ) continue;
		if ( !startswith(cond, "VS_COND_") ) continue
		
		VSCONDS_ADD_CONDITION(cond)
	}
}